#include <vector>
#include <stdlib.h> /* rand() */
#include <time.h>

#define BISQBOT_INTERNAL
#include "bisqbot.hh"
static const unsigned MAX_FRAMES = 900;

/*
  80 = enter from right side
  00 = enter from left side
*/

extern "C" unsigned char RAM[0x800];
extern "C" void BotFrontMsg(const char*fmt, ...);

/*
 100 framea htikintivaraa.
 Kyykistymisen jlkeen menee TASAN 256 framea siihen kun tuuli ilmestyy
 Kun tuuli tulee, menee noin 530 frames siihen kun tulos nkyy.
*/

void BisqBotMonitorCPU
  (unsigned short PC,
   unsigned char A,
   unsigned char X,
   unsigned char Y)
{
}

static unsigned KyykFrame;
static unsigned WalkStopFrame;
static unsigned TuuliFrame;
static unsigned VerdictFrame;

void BisqBotReset()
{
    fprintf(stderr, "restart\n");
    
    unsigned extra = (rand()%32);
    const unsigned begin = 1;
    
    KyykFrame = begin + extra;
    TuuliFrame = KyykFrame+256;
    VerdictFrame = TuuliFrame + 580;
    
    WalkStopFrame = begin + rand()%(extra+1);
    
    TuuliFrame += 10;
}

static unsigned char GenRandInput()
{
    unsigned char result = 0x00;
    switch(rand()%3)
    {
        case 0: result |= K_R; break;
        case 1: result |= K_L; break;
    }
    if(!(rand()%3)) result |= K_A;
    if(!(rand()%8)) result |= K_D;
    if(!(rand()%40))
    {
        result |= K_B;
        if(!(rand()%4)) result |= K_U;
    }
    return result;
}

unsigned char BisqBotInput(unsigned FrameNo)
{
    unsigned char Input = 0x00;
    
    if(FrameNo < WalkStopFrame) Input |= K_L;
    if(FrameNo >= KyykFrame && FrameNo <= TuuliFrame)
    {
        if(!(rand()%100)) Input |= K_L;
        if(!(rand()%100)) Input |= K_R;
        Input |= K_D;
    }
    if(FrameNo > TuuliFrame)
        Input |= GenRandInput();
    return Input;
}

unsigned BisqBotEvaluate(unsigned FrameNo)
{
    if(RAM[0x30] == 5) return 1;
    return 0; //dame
}

extern "C" void BotFrontMsg(const char*fmt, ...);
extern "C" void FCEUI_StopMovie(void);

enum BisqBotInstruction BisqBotTick(unsigned FrameNo)
{
    unsigned Place  = RAM[0x30];
    unsigned Scene  = RAM[0x50];
    unsigned Screen = RAM[0x51];
    
    if(Scene == 4 &&
      (Screen == 0x80
//    || Screen == 0xFF
    || Screen == 0x00))
    {
        BotFrontMsg("%u: Scene %02X.%02X.%02X\n", FrameNo, Place,Scene,Screen);
        return BisqBotRestart;
    }
    
    if(FrameNo == WalkStopFrame) fprintf(stderr, "- %u walkstop\n", FrameNo);
    if(FrameNo == KyykFrame) fprintf(stderr, "- %u kyyk\n", FrameNo);
    if(FrameNo == TuuliFrame) fprintf(stderr, "- %u showtime\n", FrameNo);
    if(FrameNo == VerdictFrame) fprintf(stderr, "- %u verdict time\n", FrameNo);

    if(FrameNo >= VerdictFrame)
    {
        BotFrontMsg("%u: Scene %02X.%02X.%02X\n", FrameNo, Place,Scene,Screen);
        if(Scene != 1)
        {
            fprintf(stderr, "Woohoo...\n");
            FCEUI_StopMovie();
            return BisqBotAccept;
        }
        if(!BisqBotEvaluate(FrameNo))
        {
            srand(time(0));
            return BisqBotRestart;
        }
    }
    if(BisqBotEvaluate(FrameNo) > 0)
    {
        fprintf(stderr, "It worked?!?\n");
        FCEUI_StopMovie();
        return BisqBotAccept;
    }    
    if(FrameNo > MAX_FRAMES)
    {
        BotFrontMsg("%u: Scene %02X.%02X.%02X (did nothing)\n", FrameNo, Place,Scene,Screen);
        return BisqBotRestart;
    }
    return BisqBotContinue;
}
