#include <stdio.h>

char *check[]={"SEXYAL_FMT_PCMS8","SEXYAL_FMT_PCMU8","SEXYAL_FMT_PCMS16",
"SEXYAL_FMT_PCMU16","SEXYAL_FMT_PCMS32S16","SEXYAL_FMT_PCMU32U16","SEXYAL_FMT_PCMS32S24","SEXYAL_FMT_PCMU32U24"};
char *str[]={"int8_t","uint8_t","int16_t","uint16_t","int32_t","uint32_t","int32_t","uint32_t"};

int bitss[]={8,8,16,16,16,16,24,24};
int bitsreal[]={8,8,16,16,32,32,32,32};

void BitConv(int src, int dest, char *wt)
{
 if((src^dest)&1) /* signed/unsigned change. */
  if(src&1)	/* Source unsigned, dest signed. */
  {
   if(src==1) printf(" tmp%s-=128;\n",wt);
   else if(src==3) printf(" tmp%s-=32768;\n",wt);
   else if(src==5) printf(" tmp%s-=32768;\n",wt);
   else if(src==7) printf(" tmp%s-=(1<<23);\n",wt);
  }
  else		/* Source signed, dest unsigned */
  {
   if(src==0) printf(" tmp%s+=128;\n",wt);
   else if(src==2) printf(" tmp%s+=32768;\n",wt);
   else if(src==4) printf(" tmp%s+=32768;\n",wt);
   else if(src==6) printf(" tmp%s+=(1<<23);\n",wt);
  }
 if((src>>1) != (dest>>1))
 {
  int shifty=bitss[src]-bitss[dest];
  if(shifty>0)
   printf(" tmp%s >>= %d;\n",wt,shifty);
  else
   printf(" tmp%s <<= %d;\n",wt,-shifty);
 }
}

main()
{
 int srcbits,destbits,srcchannels,destchannels;
 int srcbo,destbo;

 puts("void SexiALI_Convert(const SexyAL_format *srcformat, const SexyAL_format *destformat, void *vdest, const void *vsrc, unsigned frames)");
 puts("{");
 
 /*
         sampformat  8 bits (SEAXYAL constants)
         channels    1 bits (minus 1)
         byteorder   1 bits
  */
  
 /* Maximum value: (3&3) + 4*(4-1)  = 3+4*3 = 15 */
 puts("#define CN(x) (((x)&3) + 4*(((x)>>4)-1))");
 
 puts("switch(\n\
    ((srcformat->channels-1 )<<0)\n\
  + ((destformat->channels-1)<<1)\n\
  + ((srcformat->byteorder  )<<2)\n\
  + ((destformat->byteorder )<<3)\n\
  + ((CN(srcformat->sampformat ))<<4)\n\
  + ((CN(destformat->sampformat))<<8)) {\n");
 
 for(srcbits=0;srcbits<8;srcbits++)
 {
  for(destbits=0;destbits<8;destbits++)
  {
   for(srcchannels=0;srcchannels<2;srcchannels++)
   {
    for(destchannels=0;destchannels<2;destchannels++)
    {
     for(srcbo=0;srcbo<2;srcbo++)
     {
      for(destbo=0;destbo<2;destbo++)
      {
       const char* desttype = str[destbits];
       
       printf("case (%d)*1+(%d)*2+(%d)*4+(%d)*8+CN(%s)*16+CN(%s)*256:\n { \n",
            srcchannels,
            destchannels,
            srcbo,
            destbo,
            check[srcbits],
            check[destbits]);

       printf("const %s* src=vsrc;\n",str[srcbits]);
       
       if(destchannels && bitsreal[destbits] == 16)
           desttype = "uint32_t";
       if(destchannels && bitsreal[destbits] == 8)
           desttype = "uint16_t";
       
       printf("%s* dest=vdest;\n", desttype);
       //printf("if(srcformat->sampformat==%s && destformat->sameck[srcbits],check[destbits]);
    #if 0
       printf("unsigned count, max=frames;\n");
       printf("for(count=0; count<max; ++count) {\n");
    #else
       printf("unsigned count=frames;\n");
       printf("for(; count>0; --count) {\n");
    #endif
       
       printf(" int32_t tmp = src[count*%d+0];\n", srcchannels+1);
       
       if(srcbo) 
       {
        if(bitsreal[srcbits]==16)
         puts("FLIP16(tmp);");
        else
         puts("FLIP32(tmp);");
       }
       BitConv(srcbits,destbits,"");

       if(srcchannels) 
       {
        printf(" int32_t tmp2 = src[count*%d+1];\n", srcchannels+1);
        if(srcbo) 
        {
         if(bitsreal[srcbits]==16)
          puts("FLIP16(tmp2);");
         else
          puts("FLIP32(tmp2);");
        }
        BitConv(srcbits,destbits,"2");
       }

       if(destbo)
       { 
        if(bitsreal[srcbits]==16)
         puts("FLIP16(tmp);");
        else
         puts("FLIP32(tmp);");
        if(srcchannels && destchannels && destbo)
        {
         if(bitsreal[srcbits]==16)
          puts("FLIP16(tmp2);");   
         else
          puts("FLIP32(tmp2);");
        }
       }

       if(srcchannels && !destchannels) // downmixing
        printf("tmp = (tmp+tmp2) >> 1;\n");
       
       if(destchannels)
       {
        const char* ch1 = "tmp";
        const char* ch2 = srcchannels ? "tmp2" : "tmp";
        switch(bitsreal[destbits])
        {
          case 8:
          case 16:
            printf(" dest[count] = %s + (%s<<%u);\n", ch1, ch2, bitsreal[destbits]);
            break;
          default:
            printf(" dest[count*%d+0] = %s;\n", destchannels+1, ch1);
            printf(" dest[count*%d+1] = %s;\n", destchannels+1, ch2);
            break;
        }
       }
       else
       {
        printf(" dest[count*%d+0] = tmp;\n", destchannels+1);
       }
       
       puts("}\n break; }");
      } // destbo
     } // srcbo
    }
   }
  }
 }
 puts("}\n");
 puts("}");
}
